moDraw.light = {};
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawInfoBar.lua");
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawTextTicker.lua");
source(MultiOverlayV4.modDir.."scripte/draw/light/moDrawIconText.lua");
source(MultiOverlayV4.modDir.."scripte/draw/menue/moDrawLightSettings.lua");

function moDraw.light:setOpenDraw(pda)
	if not moGeneralSettings.pdaType.light then return;end;
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	if pdaTable == nil or pdaTable.app == nil or pdaTable.appIcon == nil then return;end;	
	moGeneralSettings.clickAreas.lightMaster["pda".. tostring(pda)] = {};
	moGeneralSettings.clickAreas.lightPda["pda".. tostring(pda)] = {};	
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	pdaTable.icon.background:render();	
	local overlay = pdaTable.icon.background;
	local tempOverlay = overlay;
	if not disableClickArea then moDraw.light:clickAreas(true, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="pda".. tostring(pda), pda=pda});end;
	local iconColor = moSetGetOverlaysLight.default.iconColor.default;
	local isInArea = false;
	if not g_currentMission.hl.dragDrop.on and g_currentMission.hl.isMouseCursor then	
		--buttonLeft--
		tempOverlay = pdaTable.icon.buttonLeft;
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x, overlay.y+(overlay.height/2)-(tempOverlay.height/2));
		isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height});
		iconColor = moSetGetOverlaysLight.default.iconColor.default;
		if isInArea then
			iconColor = moSetGetOverlaysLight.default.iconColor.select;
		elseif moSetGetOverlaysLight.default.pda[pda+1] ~= nil and moSetGetOverlaysLight.default.pda[pda+1].view[1] then
			iconColor = moSetGetOverlaysLight.default.iconColor.open;
		end;		
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(iconColor, true));
		tempOverlay:render();
		if not disableClickArea then moDraw.light:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="pda".. tostring(pda), whereClick="buttonLeft_", pda=pda});end;
		--buttonLeft--
		--buttonSetting--		
		tempOverlay = pdaTable.icon.buttonSetting;
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width), overlay.y+(overlay.height/2)-(tempOverlay.height/2));
		isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height});
		iconColor = moSetGetOverlaysLight.default.iconColor.default;
		if isInArea then
			iconColor = moSetGetOverlaysLight.default.iconColor.select;
		elseif moSetGetOverlaysLight.default.setting.on and moSetGetOverlaysLight.default.setting.selectPda == pda then
			iconColor = moSetGetOverlaysLight.default.iconColor.open;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(iconColor, true));
		if moSetGetOverlaysLight.default.setting.on and moSetGetOverlaysLight.default.setting.selectPda == pda then
			if g_currentMission.hl.runsTimer("1sec", true) then
				tempOverlay:render();
			end;
		else
			tempOverlay:render();
		end;
		if not disableClickArea then moDraw.light:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="pda".. tostring(pda), whereClick="buttonSetting_", pda=pda});end;
		--buttonSetting--
	end;	
	local optiSize = moSetGetOverlaysLight.default.optiHeightSize;
	local viewApps = 0;
	local leftPosX = pdaTable.icon.buttonLeft.x+pdaTable.icon.buttonLeft.width;	
	
	for app=1, #pdaTable.appIconView do
		if pdaTable.appIcon[pdaTable.appIconView[app]] ~= nil then
			local tempApp = pdaTable.appIconView[app];
			local appOrder = pdaTable.app[tempApp];
			overlay = pdaTable.appIcon[tempApp];
			g_currentMission.hl.setOverlay(overlay, leftPosX+(moSetGetOverlaysLight.default.appWidth*(viewApps)));			
			iconColor = moSetGetOverlaysLight.default.iconColor.default;
			isInArea = moDraw.light:getIconSelectColor(disableClickArea, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height});
			local appInfoBar = false;
			function setIconColor()
				if appOrder.onDrawColorState ~= nil and type(appOrder.onDrawColorState) == "function" then
					local state = appOrder.onDrawColorState( {app=appOrder} );
					if state ~= nil then
						if not state then
							appInfoBar = true;						
						end;
						if isInArea then 
							iconColor = moSetGetOverlaysLight.default.iconColor.select;
						elseif state then
							iconColor = moSetGetOverlaysLight.default.iconColor.open;						
						end;
					else
						if isInArea then iconColor = moSetGetOverlaysLight.default.iconColor.selectInactive;else iconColor = moSetGetOverlaysLight.default.iconColor.inactive;end;
					end;
				else
					if isInArea then iconColor = moSetGetOverlaysLight.default.iconColor.selectInactive;else iconColor = moSetGetOverlaysLight.default.iconColor.inactive;end;
				end;				
			end;
			setIconColor();
			if tempApp == pdaTable.selectApp and (moSetGetOverlaysLight.default.keyInteraction) then
				g_currentMission.hl.setOverlay(pdaTable.icon.appSelect, overlay.x, nil, overlay.width);
				pdaTable.icon.appSelect:render();
			end;			
			iconColor = g_currentMission.hl.getColor(iconColor, true);
			g_currentMission.hl.setBackgroundColor(overlay, iconColor);
			overlay:render();			
			if not disableClickArea then moDraw.light:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="pda".. tostring(pda), whereClick="appIcon_", app=tempApp, pda=pda});end;
			if appInfoBar then
				moDraw["infoBar"]:setPda(overlay, disableClickArea, pdaTable, appOrder);				
			end;
			if moGeneralSettings.textTicker.isOn then moDraw.textTicker:setPda(pdaTable, appOrder);end;
			moDraw.iconText:setPda(overlay, appOrder, moSetGetOverlaysLight.default.optiHeightSize, iconColor, isInArea);
			viewApps = viewApps+1;
		end;
	end;	
	setTextBold(false);	
	setTextColor(1, 1, 1, 1);
end;

function moDraw.light:getIconSelectColor(disableClickArea, value)
	if disableClickArea then return false;end;
	return g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack(value))
end;

function moDraw.light:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.lightMaster[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
			pda=args.pda;
		};
	else	
		if moGeneralSettings.clickAreas.lightPda[args.whatClick] == nil then moGeneralSettings.clickAreas.lightPda[args.whatClick] = {};end;
		moGeneralSettings.clickAreas.lightPda[args.whatClick][#moGeneralSettings.clickAreas.lightPda[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1			
			mouseClick = "";
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			app = args.app;
			pda = args.pda;
		};		
	end;
end;