moLanguageXml = {};

function moLanguageXml:loadTable()	
	moLanguage = {};
	MultiOverlayV4.language = "_".. string.lower(g_languageShort);
	MultiOverlayV4.languageAccepts = {"_en"; "_de"; "_nl"; "_es"; "_it"; "_fr"; "_hu"; "_pl"; "_ru"; "_ro"};	
	moLanguageXml:loadLanguages();
end;


--tostring(moLanguageXml:getTxt("setfrozeninfo", nil, nil, nil, true))
function moLanguageXml:getTxt(text, maxString, oldNameReturn, toLong, intern)	
	local txt = "L Error";
	local toLongTxt = "";
	local languageXML = moLanguage;
	if intern then languageXML = moLanguageIntern;end;
	local languageTable = MultiOverlayV4.language;
	if languageXML ~= nil and languageXML[text] ~= nil then
		if languageXML[text][languageTable] == nil then			
			for a=1, #MultiOverlayV4.languageAccepts do
				if languageXML[text][MultiOverlayV4.languageAccepts[a]] ~= nil then txt = languageXML[text][MultiOverlayV4.languageAccepts[a]];break;end; --languageTable = MultiOverlayV4.languageAccepts[a];break;end;
			end;
		else
			txt = languageXML[text][languageTable];
		end;		
		if maxString ~= nil then
			local cutName = txt;			
			if string.len(cutName) > tonumber(maxString) then
				if toLong ~= nil and toLong then maxString = maxString-2;toLongTxt = ".."end;
				cutName = string.sub(txt, 0, tonumber(maxString)).. toString(toLongTxt);
			end;
			txt = cutName;
		end;		
		if txt == nil or string.len(txt) == 0 then txt = "L Missing";end;
	end;
	if oldNameReturn ~= nil then
		if txt == "L Missing" or txt == "L Error" then txt = oldNameReturn;end;
	end;
	return txt;
end;

function moLanguageXml:loadLanguages()		
	moDeleteOldLanguage = {};
	moLanguageDefault = {								
		year = 					{_de="Jahr",					_en="Year",						_nl="Jaar",				_fr="Année",		_pl="Rok",		_ru="Год",		_it="Anno",		_es="Año",		_hu="Év",		_ro="An"};
		years = 				{_de="Jahre",					_en="Years",					_nl="Jaren",			_fr="Années",		_pl="Lata",		_ru="Годы",		_it="Anni",		_es="Años",		_hu="Évek",		_ro="Ani"};
		on = 					{_de="An",						_en="On",						_nl="Aan"};
		off = 					{_de="Aus",					 	_en="Off",						_nl="Uit"};
		yes = 					{_de="Ja", 						_en="Yes",						_nl="Yes"};
		no = 					{_de="Nein", 					_en="No",						_nl="No"};
		per = 					{_de="pro", 					_en="per",						_nl="per"};
		siloextensions = 		{_de="Siloerweiterung", 		_en="Siloextension"};
		money = 				{_de="Geld", 					_en="Money"};
		moneysymbol = 			{_de="€", 						_en="€"};
		moneycurrency = 		{_de="Euro", 					_en="Euro"};
		day1 = 					{_de="(Mo)", 					_en="(Mon)"};
		day2 = 					{_de="(Di)", 					_en="(Tue)"};
		day3 = 					{_de="(Mi)", 					_en="(Wed)"};
		day4 = 					{_de="(Do)",	 				_en="(Thu)"};
		day5 = 					{_de="(Fr)", 					_en="(Fri)"};
		day6 = 					{_de="(Sa)", 					_en="(Sat)"};
		day7 = 					{_de="(So)", 					_en="(Sun)"};		
		day = 					{_de="Tag", 					_en="Day"};
		days = 					{_de="Tag(e)", 					_en="Day(s)"};
		playdays = 				{_de="Spieltage", 				_en="PlayDays";					_nl="Speldagen"};
		productivity = 			{_de="Produktivität", 			_en="Productivity"};
		usage = 				{_de="Auslastung",				_en="Usage"};
		capacity = 				{_de="Kapazität", 				_en="Capacity"};
		field = 				{_de="Feld", 					_en="Field"};
		fields = 				{_de="Felder",					_en="Fields"};
		price = 				{_de="Preis", 					_en="Price"};
		prices = 				{_de="Preise", 					_en="Prices"};		
		hectar = 				{_de="Hectar", 					_en="Hectar"};
		fieldstotal = 			{_de="Felder gesamt", 			_en="Fieldstotal"};
		foodtrough = 			{_de="Futtertrog",				_en="Foodtrough"};
		empty = 				{_de="-Leer-", 					_en="-Empty-"};
		times = 				{_de="Zeit", 					_en="Time"};
		times1 = 				{_de="Zeiten", 					_en="Times"};
		hours = 				{_de="Stunden", 				_en="Hours"};
		hour = 					{_de="Stunde", 					_en="Hour"};	
		at = 					{_de="in", 						_en="at"};
		big = 					{_de="extra groß", 				_en="big"};
		large = 				{_de="groß", 					_en="large"};
		middle = 				{_de="mittel", 					_en="middle"};
		small = 				{_de="klein", 					_en="small"};
		shop = 					{_de="Shop", 					_en="Shop"};
		tree = 					{_de="Baum", 					_en="Tree"};
		trees = 				{_de="Bäume", 					_en="Trees"};
		bale = 					{_de="Ballen", 					_en="Bale"};
		farm = 					{_de="Bauernhof", 				_en="Farm"};
		owner = 				{_de="Eigene", 					_en="Owner"};
		ownernofound = 			{_de="Keine gefunden", 			_en="Not Found"};
		farmsilos = 			{_de="Hofsilo", 				_en="Farmsilo"};
		silo = 					{_de="Silo", 					_en="Silo"};
		silos = 				{_de="Silos", 					_en="Silos"};
		train = 				{_de="Zug", 					_en="Train" };
		trains = 				{_de="Züge", 					_en="Trains" };
		level = 				{_de="Stufe", 					_en="Level" };
		levels = 				{_de="Stufen", 					_en="Levels" };
		fruit = 				{_de="Frucht", 					_en="Fruit"};	
		fruittype = 			{_de="Fruchtart", 				_en="Fruittype"};
		fruits = 				{_de="Früchte", 				_en="Fruits"};
		stock = 				{_de="Lager", 					_en="Stock"};
		amount = 				{_de="Bestand", 				_en="Amount"};
		potatos = 				{_de="Kartoffeln", 				_en="Potatos"};
		sugarbeets = 			{_de="Zuckerrüben",				_en="Sugarbeets"};
		grass = 				{_de="Gras", 					_en="Grass"};
		straw = 				{_de="Stroh", 					_en="Straw"};
		food = 					{_de="Futter", 					_en="Food"};
		silage = 				{_de="Silage", 					_en="Silage"};
		manure = 				{_de="Mist", 					_en="Manure"};
		liquidmanure = 			{_de="Gülle", 					_en="Liquidmanure"};
		age = 					{_de="Alt", 					_en="Age"};
		ages = 					{_de="Alter", 					_en="Ages"};
		ageday =				{_de="Tag", 					_en="Day"};
		agedays =				{_de="Tage", 					_en="Days"};
		animal = 				{_de="Tier", 					_en="Animal"};
		animals = 				{_de="Tiere", 					_en="Animals"};		
		egg = 					{_de="Eier", 					_en="Eggs"};
		eggsbarn = 				{_de="Eier im Stall", 			_en="Eggs in the barn",			_nl="Eieren in de schuur"};
		pickup = 				{_de="Eier im Rucksack", 		_en="Eggs carrying",			_nl="Eggs carrying"};
		wool = 					{_de="Wolle", 					_en="Wool"};
		cow = 					{_de="Kühe", 					_en="Cow"};
		sheep = 				{_de="Schafe", 					_en="Sheep"};
		chicken = 				{_de="Hühner", 					_en="Chicken"};
		pig = 					{_de="Schweine", 				_en="Pig"};	
		horse = 				{_de="Pferde", 					_en="Horse"};
		animalsstall = 			{_de="Tierställe", 				_en="Animalstall"};
		animalstall = 			{_de="Tierstall", 				_en="Animalstall"};
		factory = 				{_de="Fabrik", 					_en="Factory"};
		factorys = 				{_de="Fabriken", 				_en="Factorys"};
		harvest = 				{_de="Erntereif", 				_en="Harvest"};
		growth = 				{_de="Wachstum", 				_en="Growth"};
		--cut = 					{_de="Alte Saat"};
		plough = 				{_de="Gegrubert", 				_en="Plough"};
		plowing = 				{_de="Pflügen", 				_en="Plowing"};
		weeds = 				{_de="Unkraut", 				_en="Weeds"};
		lime = 					{_de="Kalk", 					_en="Lime"};
		fertilizer = 			{_de="Flüssigdünger", 			_en="Fertilizer"};
		sprayed = 				{_de="Gedüngt", 				_en="Sprayed"};
		sprayer = 				{_de="Gespritzt", 				_en="Sprayer"};
		windrow = 				{_de="Gedroschen", 				_en="Windrows"};
		wasteland =	 			{_de="Brachland", 				_en="Wasteland"};
		oldseed = 				{_de="Alte Saat", 				_en="Oldseed"};
		seed = 					{_de="Saat", 					_en="Seed"};
		seeds = 				{_de="Gesaet", 					_en="Seeds"};
		station = 				{_de="Station", 				_en="Station"};
		sellingstations =  		{_de="Verkauf Stationen", 		_en="Selling Stations"};		
		buyingstations =  		{_de="Einkauf Stationen", 		_en="Buying Stations"};
		buyingwater =  			{_de="Wasserstelle", 			_en="Watering hole"};
		unknown = 				{_de="Unbekannt", 				_en="Unknown"};
		costday = 				{_de="Kosten(Tag)", 			_en="Cost(Day)"};
		fillcontainer = 		{_de="Füllbehälter", 			_en="Fillcontainer"};
		factor = 				{_de="Faktor", 					_en="Factor"};
		pallets = 				{_de="Pal.", 					_en="Pal."};
		cleanliness = 			{_de="Sauberkeit", 				_en="Cleanliness"};
		total = 				{_de="Total", 					_en="Total"};
		incomeperhour =			{_de="Einnahmen(Stunde)", 		_en="Income(Hour)"};
		greenhouses =			{_de="Gewächshäuser", 			_en="Greenhouses"};
		greenhouse =			{_de="Gewächshaus", 			_en="Greenhouse"};
		windturbine =			{_de="Windturbine", 			_en="Windturbine"};
		windturbinen =			{_de="Windturbinen", 			_en="Windturbinen"};
		solarcollector =		{_de="Solaranlage", 			_en="Solarcollector"};
		solarcollectoren =		{_de="Solaranlagen", 			_en="Solarcollectoren"};
		heatingplant =			{_de="Heizkraftwerk", 			_en="Heatingplant"};
		heatingplants =			{_de="Heizkraftwerke", 			_en="Heatingplants"};
		beehivehouse =			{_de="Bienenhaus", 				_en="Beehivehouse"};
		beehivehouses =			{_de="Bienenhäuser", 			_en="Beehivehouses"};		
		bgas =					{_de="BGAs", 					_en="BGAs"};
		bga =					{_de="BGA", 					_en="BGA"};
		catcher =				{_de="Shredder", 				_en="Catcher"};
		missionharvest =		{_de="Ernten", 					_en="Harvest"};
		missionsow =			{_de="Saen", 					_en="Sow"};
		missionfertilize =		{_de="Düngen", 					_en="Fertilize"};
		missionweed =			{_de="Mähen", 					_en="Weed"};
		missiontransport =		{_de="Transportieren", 			_en="Transport"};
		missionmow_bale =		{_de="Ballenpressen", 			_en="Baling"};
		missionplow =			{_de="Pflügen", 				_en="Plow"};
		missioncultivate =		{_de="Grubern", 				_en="Cultivate"};
		missionspray =			{_de="Sprühen", 				_en="Spray"};
		reproductionrate =		{_de="Reproduktionsrate", 		_en="Reproductionrate"};
		full = 					{_de="Voll",					_en="Full"};
		bunker = 				{_de="Bunker",					_en="Bunker"};
		bunkersilo = 			{_de="BunkerSilo",				_en="BunkerSilo"};
		bunkersilos = 			{_de="BunkerSilos",				_en="BunkerSilos"};
		bunkercompact = 		{_de="Verdichtung",				_en="Compression"};
		bunkercompactfilllevel= {_de="Füllstand C",				_en="FillLevel C"};
		bunkerfermenting = 		{_de="Gärung",					_en="Ferment"};
		bunkerfilllevel = 		{_de="Füllstand",				_en="FillLevel"};
		greatdemand = 			{_de="Große Nachrage",			_en="GreatDemand"};
		feedmixers = 			{_de="FutterMischer",			_en="FeedMixers"};
		storage = 				{_de="Lager",					_en="Storage"};
		storages = 				{_de="Lagers",					_en="Storages"};
		objectstorages = 		{_de="ObjectLagers",			_en="ObjectStorages"};
		filltypemovers = 		{_de="Fabrik(FM)",				_en="Factory(FM)"};
		finish = 				{_de="Fertig",					_en="Finish"};
	};
	
	moLanguageIntern = {
		mohV3ninfo = {_de="Aktiviere oder Deaktivier den Mod\n!! Achtung Siehe auch HILFE !!",	_en="Set On or Off\n!! ATTENTION VIEW HELP !!"};
		mohV3nhelp1 = {_de="Ist der Mod Deaktiviert\ndann Aktiviere dieses Menue mit der\nStandart Taste (F12)\n'MoV3OnOffMouseCursor' --> LS19 Tastatur Belegung",	_en="Is MOH OFF then Activate this GuiMenue with Default Key(F12)\n'MoV3OnOffMouseCursor' ----> LS19 Keypad Settings Optionen"};
		keyselectinfo = {_de="Aktiviere oder Deaktivier die Tastatur Steuerung", _en="Set KeySelect On or Off"};
		keyselecthelp1 = {_de="Optional kann man die PDAs mit den Tasten Steuern\nStandart ist das der Pfeiltasten Block\nLinks/Rechts/Hoch/Runter", _en="Optional set KeySelect for Control PDAs with keypad\nDefault Left/Right/Up/Down KeyPadBlock"};
		setfrozeninfo = {_de="Ist der MouseCoursor An dann wird die Spieler Bewegung Automatisch eingefroren", _en="Is MouseCursor ON then set Player Frozen"};
		setfrozenhelp1 = {_de="Andere Mods können das Verhindern/Blockieren oder Aufheben", _en="Another mod can prevent/obstruct that"};
		widthHeightZoomSlot = { _de="Sie können die Slot Größe unten rechts ändern (im Slot)\nMit der Maus können Sie bei Bedarf nach oben und unten scrollen(+IconButton)\nund ggf. mit dem Schieberegler(+Maus) nach links oder rechts", _en="You can change the slot size at the bottom right (at slot)\nWith the mouse you can scroll up and down if necessary(+IconButton)\nand with the slider(+Mouse) to the left or right if necessary"};
		pdaTypeLightFirstStart = { _de="!! Neuen PDA Type (light) gefunden !!\nSoll dieser Aktiviert werden ?\n(Global PDA für alle Profile)\n*Optional An/Aus diesen PDA Type via GUI Menü\n--> (MultiOverlayV4 / GlobalSettings)\n! Deine MOH PDA Huds überlappen event. den neue PDA Type !\n(setze diese auf neue Positionen)", _en="!! Found New PDA Type (light) !!\nNew PDA Type (light) Activate ?\n(Global PDA for all Profile)\n*Optional On/Off this PDA Type via GUI Menue\n--> (MultiOverlayV4 / GlobalSettings)\n! Your MOH PDA Huds possible overlap new PDA Type !\n(set this to new positions)"};
		pdaTypeLightGeneratePda = { _de="!! PDA nicht gefunden !!\nSoll dieser erstellt werden (Clone) ?\n(Global PDA für alle Profile)\n! Deine MOH PDA Huds überlappen event. das neue PDA !\n(setze diese auf neue Positionen)", _en="!! Not Found PDA !!\nPDA Generate (Clone) ?\n(Global PDA for all Profile)\n! Your MOH PDA Huds possible overlap new PDA !\n(set this to new positions)"};
	};
end;

function moLanguageXml:randomTextTickerTxt(playerName) 
	local txt = {g_i18n:getText("achievement_descBreedChicken"),g_i18n:getText("achievement_descPlayTime"),playerName.. g_i18n:getText("ui_howDoYouLikeTheGame"),playerName.. g_i18n:getText("achievement_nameLoadedOldSavegame"),playerName.. g_i18n:getText("achievement_descPetDog"),g_i18n:getText("achievement_descLoadedOldSavegame".. playerName),
	g_i18n:getText("achievement_nameDeliveryOlives").. playerName,g_i18n:getText("achievement_descBreedCows").. " ".. g_i18n:getText("achievement_descBreedPigs"),playerName.. g_i18n:getText("achievement_descCollectiblesUS"),g_i18n:getText("achievement_descCollectiblesAlpine"),g_i18n:getText("achievementFileDescription_psn").. " ".. g_i18n:getText("achievement_descCollectiblesFR"), 
	g_i18n:getText("ui_ingameMenuHelpLine").. playerName.. " ".. g_i18n:getText("achievement_descMoney"),playerName.. g_i18n:getText("achievement_descNumDrivables"),playerName.. g_i18n:getText("achievement_descNumPlaceables"),g_i18n:getText("achievement_descSowFirst").. playerName.. " ".. g_i18n:getText("function_mower"),playerName.. g_i18n:getText("achievement_descVehicleRepaint"),
	g_i18n:getText("achievement_descVehicleRepairFirst").. playerName,g_i18n:getText("achievement_nameBreedChicken").. " ".. g_i18n:getText("achievement_descPlayTime"),playerName.. g_i18n:getText("achievement_nameBreedCows"),g_i18n:getText("achievement_nameBreedPigs").. " ".. g_i18n:getText("achievement_nameBreedSheep"),g_i18n:getText("achievement_nameCollectiblesAlpine").. playerName.. " ".. g_i18n:getText("achievement_nameCottonBales"),
	g_i18n:getText("achievement_nameCarDriving").. " ".. g_i18n:getText("achievement_nameCollectiblesUS").. playerName,g_i18n:getText("achievement_nameCutTreeFirst").. " ".. g_i18n:getText("achievement_nameCollectiblesFR"),g_i18n:getText("achievement_nameDeliverySorghum").. playerName.. " ".. g_i18n:getText("achievement_nameDeliveryGrapes"),
	g_i18n:getText("achievement_nameFertilize").. " ".. g_i18n:getText("achievement_descSow"), g_i18n:getText("achievement_descTruckDriving").. playerName,g_i18n:getText("achievement_nameGotAllAchievements").. " ".. g_i18n:getText("achievement_nameHarvested"),g_i18n:getText("achievement_nameHarvestedFirst").. " ".. g_i18n:getText("achievement_nameHorseJumps"),
	playerName.. g_i18n:getText("achievement_nameMission"),g_i18n:getText("achievement_nameMissionFirst").. " ".. g_i18n:getText("achievement_nameMoney").. playerName,g_i18n:getText("achievement_nameNumBeehives"),g_i18n:getText("achievement_descCultivate"),playerName.. g_i18n:getText("achievement_descCultivateFirst"),
	playerName.. g_i18n:getText("achievement_descCutTreeFirst").. " ".. g_i18n:getText("achievement_descCutTree"),g_i18n:getText("achievement_descHarvestedFirst"),g_i18n:getText("ui_collectibleMessageTitle").. " ".. g_i18n:getText("achievement_nameWrappedBales"),g_i18n:getText("achievement_nameCultivateFirst"),
	g_i18n:getText("achievement_nameNumVehiclesLarge"),g_i18n:getText("achievement_descDeliveryGrapes"),g_i18n:getText("achievement_nameNumProductionPoints").. playerName,g_i18n:getText("achievement_descMissionFirst"),g_i18n:getText("achievement_descFertilizeFirst"),g_i18n:getText("achievement_descHarvested"),
	playerName.. g_i18n:getText("achievement_nameSowFirst"),g_i18n:getText("achievement_nameNumPlaceables").. playerName,g_i18n:getText("achievement_nameTruckDriving").. playerName.. " ".. g_i18n:getText("achievement_nameNumVehiclesSmall"),g_i18n:getText("achievement_namePetDog"),g_i18n:getText("achievement_namePlayTime").. playerName.. " ".. g_i18n:getText("achievement_nameTractorDriving"),g_i18n:getText("achievement_nameSow"),
	g_i18n:getText("achievement_nameVehicleRepaint").. " ".. g_i18n:getText("achievement_nameVehicleRepairFirst"),g_i18n:getText("achievement_descGotAllAchievements"),g_i18n:getText("info_tipSideBack").. " ".. g_i18n:getText("achievement_descFertilize"),playerName.. g_i18n:getText("achievement_descDeliveryStones"),g_i18n:getText("achievement_descDeliverySorghum"),
	playerName.. g_i18n:getText("achievement_descDeliveryOlives"),g_i18n:getText("statistic_eggsCarrying").. " ".. g_i18n:getText("achievement_descCottonBales"),g_i18n:getText("achievement_nameHorseRiding").. " ".. g_i18n:getText("achievement_nameHorseJumpsFirst"),g_i18n:getText("ui_kickTitle").. " ".. g_i18n:getText("achievement_descNumBeehives"),
	 g_i18n:getText("achievement_nameHorseRidingFirst").. " ".. g_i18n:getText("achievement_descHorseRidingFirst")}; 
	local randomTxt = math.random(1, #txt);
	return txt[randomTxt];
end;
