moSetGet = {};

function moSetGet:setPlayerPos()
	if moGeneralSettings.other.viewPlayerPos and not g_currentMission.hl.isMouseCursor then
		local ingameMap = g_currentMission.hud.ingameMap;
		local inGameMapState = g_currentMission.hl.getIngameMapState();
		if ingameMap ~= nil and (inGameMapState == 2 or inGameMapState == 3) then		
			local baseX, baseY = ingameMap:getPosition();
			local baseWidth = ingameMap:getWidth();
			local baseHeight = ingameMap:getHeight();
			--local width = ingameMap.toggleMapSizeGlyph:getWidth()
			--local height = ingameMap.toggleMapSizeGlyph:getHeight()
			local posX = baseX + (baseWidth/2);
			local posY = baseY + baseHeight + getTextHeight(0.011, "Äy");
			local x, y, z = g_currentMission.hl.getPlayerPos();
			if x ~= nil and y ~= nil and z ~= nil then 
				x=g_i18n:formatNumber(x);y=g_i18n:formatNumber(y);z=g_i18n:formatNumber(z);
				local txt = "x".. tostring(x).. "  y".. tostring(y).. "  z".. tostring(z);
				local txtWidth = getTextWidth(0.010, txt);
				setTextBold(true);			
				renderText(posX-(txtWidth/2), posY, 0.010, txt);
				setTextBold(false);
			end;			
		end;		
	end;
end;

function moSetGet:setMiniMapState()
	if not moGeneralSettings.miniMapAutoState.on then return;end;	
	if moGeneralSettings.miniMapAutoState.viewIcons then moDraw.miniMapAutoState:setOpen();end;
	local inGameMapState = g_currentMission.hl.getIngameMapState();
	if moGeneralSettings.miniMapAutoState.state[inGameMapState] then return;end;	
	local setNew = false;
	function setState(state)
		g_currentMission.hud.ingameMap.layout:deactivate();
		--if state == 5 then --later set fullScreen for more details			
			--g_currentMission.hud.ingameMap.isFullscreen = true;
			--g_currentMission.hud.ingameMap.layout = g_currentMission.hud.ingameMap.fullScreenLayout;
		--else
			g_currentMission.hud.ingameMap.state = state;
			g_currentMission.hud.ingameMap.layout = g_currentMission.hud.ingameMap.layouts[state];
			g_currentMission.hud.ingameMap.layout:activate();
		--end;		
		g_inputBinding:setActionEventTextVisibility(g_currentMission.hud.ingameMap.toggleMapSizeEventId, g_currentMission.hud.ingameMap.layout:getShowsToggleActionText())
		g_gameSettings:setValue("ingameMapState", state, true)
		--if state ~= 5 then g_gameSettings:setValue("ingameMapState", state, true);end;		
	end;	
	if inGameMapState <= 4 then			
		if moGeneralSettings.miniMapAutoState.state[inGameMapState] ~= nil and not moGeneralSettings.miniMapAutoState.state[inGameMapState] then 		
			for a=inGameMapState, 4 do
				if moGeneralSettings.miniMapAutoState.state[a] ~= nil and moGeneralSettings.miniMapAutoState.state[a] then					
					setState(a)
					setNew = true;
					break;					
				end;
			end;
		end;
		if not setNew then setState(1);end;
	end;	
	return;	
end;

function moSetGet:disableClickAreas()
	return g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
end;

function moSetGet:errorSetMiniMapAutoState()
	return not moGeneralSettings.miniMapAutoState.state[1] and not moGeneralSettings.miniMapAutoState.state[2] and not moGeneralSettings.miniMapAutoState.state[3];
end;

function moSetGet:setMiniMapAutoState(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.whatClick == "miniMapAutoStateIcon" then
		local state = Utils.getNoNil(tonumber(args.whereClick), 0);
		if state == 0 then return;end;
		moGeneralSettings.miniMapAutoState.state[state] = not moGeneralSettings.miniMapAutoState.state[state];
		if moSetGet:errorSetMiniMapAutoState() then moGeneralSettings.miniMapAutoState.state[1] = true;end;
	end;
end;

function moSetGet:setVehicleCamera()	
	if g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.spec_enterable ~= nil then
		local vehicle = g_currentMission.controlledVehicle;
		local spec = vehicle.spec_enterable;
		local camIndex = spec.camIndex;
		if spec.cameras[camIndex] ~= nil then
						
		end;
	end;	
end;

function moSetGet:setWtmState(typ, state, all)
	moSetGet:refreshTemperature();
	moSetGet:refreshDate();
	if typ == "ShowWeather" or all then
		g_currentMission.hud.gameInfoDisplay:setWeatherVisible(state);
	end;
	if typ == "ShowTemperature" or all then		
		g_currentMission.hud.gameInfoDisplay:setTemperatureVisible(state);
	end;
	if typ == "ShowIngameDate" or all then
		g_currentMission.hud.gameInfoDisplay:setDateVisible(state);
		if not state then moGeneralSettings.clickAreas.lsWTM["lsDateBox_"] = {};end;
	end;
	if typ == "ShowIngameTime" or all then
		g_currentMission.hud.gameInfoDisplay:setTimeVisible(state);
	end;
	if typ == "ShowMoney" or all then
		g_currentMission.hud.gameInfoDisplay:setMoneyVisible(state);
		if not state then moGeneralSettings.clickAreas.lsWTM["lsMoneyBox_"] = {};end;
	end;	
end;

function moSetGet:refreshTemperature()	
	if moGeneralSettings.wtm.temperature.defaultX ~= nil then			
		g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay, moGeneralSettings.wtm.temperature.defaultX);
		g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconRising.overlay, moGeneralSettings.wtm.temperature.defaultX);
		g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconDropping.overlay, moGeneralSettings.wtm.temperature.defaultX);			
		moGeneralSettings.wtm.temperature.defaultX = nil;
		if moGeneralSettings.wtm.temperature.defaultSize ~= nil then
			g_currentMission.hud.gameInfoDisplay.temperatureTextSize = moGeneralSettings.wtm.temperature.defaultSize;
		end;
	end;	
end;

function moSetGet:refreshDate()	
	if moGeneralSettings.wtm.ingamedate.defaultY ~= nil then			
		g_currentMission.hud.gameInfoDisplay.monthTextPositionY = moGeneralSettings.wtm.ingamedate.defaultY;
		moGeneralSettings.wtm.ingamedate.defaultY = nil;
		if moGeneralSettings.wtm.ingamedate.defaultSize ~= nil then
			g_currentMission.hud.gameInfoDisplay.monthTextSize = moGeneralSettings.wtm.ingamedate.defaultSize;
		end;
	end;	
end;

if not MultiOverlayV4:getServer() then	
	function moSetGet.updateTemperature(self)	
		local minTemp, maxTemp = self.environment.weather:getCurrentMinMaxTemperatures()
		local currentTemp = self.environment.weather:getCurrentTemperature();
		local color = GameInfoDisplay.COLOR.ICON;		
		if moGeneralSettings.wtm.temperature.color then
			if currentTemp > 5 and currentTemp <= 10 then
				color = g_currentMission.hl.getColor("green", true);
			elseif currentTemp > 10 and currentTemp <= 20 then
				color = g_currentMission.hl.getColor("yellow", true);
			elseif currentTemp > 20 and currentTemp <= 30 then
				color = g_currentMission.hl.getColor("darkYellow", true);	
			elseif currentTemp > 30 then
				color = g_currentMission.hl.getColor("red", true);
			end;
		end;		
		g_currentMission.hl.setBackgroundColor(g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay, color);
		g_currentMission.hl.setBackgroundColor(g_currentMission.hud.gameInfoDisplay.temperatureIconRising.overlay, color);
		g_currentMission.hl.setBackgroundColor(g_currentMission.hud.gameInfoDisplay.temperatureIconDropping.overlay, color);		
		if moGeneralSettings.wtm.temperature.modus ~= 4 and moGeneralSettings.wtm.temperature.defaultX ~= nil then
			self.temperatureTextSize = moGeneralSettings.wtm.temperature.defaultSize;
			if g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay.x ~= moGeneralSettings.wtm.temperature.defaultX then
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay, moGeneralSettings.wtm.temperature.defaultX);
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconRising.overlay, moGeneralSettings.wtm.temperature.defaultX);
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconDropping.overlay, moGeneralSettings.wtm.temperature.defaultX);
			end;
		end;
		if moGeneralSettings.wtm.temperature.modus == 1 or moGeneralSettings.wtm.temperature.modus == 2 or moGeneralSettings.wtm.temperature.modus == 3 then
			self.temperatureDayText = string.format("%d°", maxTemp);
			self.temperatureNightText = string.format("%d°", minTemp);
		elseif moGeneralSettings.wtm.temperature.modus == 4 then
			local x, y, width, height = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.temperatureBox.overlay);			
			if moGeneralSettings.wtm.temperature.defaultX == nil then 
				moGeneralSettings.wtm.temperature.defaultX = g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay.x;
				moGeneralSettings.wtm.temperature.defaultSize = self.temperatureTextSize;				
			end;
			local minMaxTxt = string.format("%d°/%d°", minTemp, maxTemp);
			local w = g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay.width
			local optiSize = g_currentMission.hl.optiWidthSize(width-(w-0.006), minMaxTxt, self.temperatureTextSize);
			self.temperatureTextSize = optiSize ;
			if moGeneralSettings.wtm.temperature.order == 1 then
				self.temperatureDayText = minMaxTxt;
				self.temperatureNightText = "";			
			else
				self.temperatureDayText = "";
				self.temperatureNightText = minMaxTxt;
			end;
			if g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay.x ~= g_currentMission.hud.gameInfoDisplay.temperatureBox.overlay.x-0.003 then
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay, x-0.003);
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconRising.overlay, x-0.003);
				g_currentMission.hl.setOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconDropping.overlay, x-0.003);
			end;
		elseif moGeneralSettings.wtm.temperature.modus == 5 then
			if not g_currentMission.hl.runsTimer("15sec", true) and g_currentMission.hl.runsTimer("12sec", true) then
				self.temperatureDayText = ""; --string.format("%d°", currentTemp);
				self.temperatureNightText = "";
			else
				self.temperatureDayText = string.format("%d°", maxTemp);
				self.temperatureNightText = string.format("%d°", minTemp);			
			end;	
		end;		
	end;
	function moSetGet.drawTemperatureTxt(self)		
		local currentTemp = self.environment.weather:getCurrentTemperature();
		if moGeneralSettings.wtm.temperature.modus == 2 or moGeneralSettings.wtm.temperature.modus == 3 then
			local currentTempTxt = string.format("%d°", currentTemp);
			local x, y, width, height = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.temperatureIconStable.overlay);
			local bX, bY, _, bHeight = g_currentMission.hl.getOverlay(self.backgroundOverlay.overlay);					
			local optiSize = GameInfoDisplay.TEXT_SIZE.TEMPERATURE;			
			local diff = 0.003;
			if moGeneralSettings.wtm.temperature.modus == 3 then
				optiSize = g_currentMission.hl.optiHeightSize(bY+bHeight-(y+height), currentTempTxt, GameInfoDisplay.TEXT_SIZE.TEMPERATURE);
				bY = y+height-diff+0.001;
			else
				optiSize = g_currentMission.hl.optiHeightSize(y-bY, currentTempTxt, GameInfoDisplay.TEXT_SIZE.TEMPERATURE);
			end;
			--local txtWidth = getTextWidth(optiSize, utf8Substr(currentTempTxt, 0));			
			local txtColor = moGeneralSettings.wtm.temperature.txtColor;
			if moGeneralSettings.wtm.temperature.txtColor == 0 then 
				if moGeneralSettings.wtm.temperature.color then
					if currentTemp <= 5 then
						txtcolor = GameInfoDisplay.COLOR.ICON;
					elseif currentTemp > 5 and currentTemp <= 10 then
						txtColor = g_currentMission.hl.getColor("green", true);
					elseif currentTemp > 10 and currentTemp <= 20 then
						txtColor = g_currentMission.hl.getColor("yellow", true);
					elseif currentTemp > 20 and currentTemp <= 30 then
						txtColor = g_currentMission.hl.getColor("darkYellow", true);	
					elseif currentTemp > 30 then
						txtColor = g_currentMission.hl.getColor("red", true);
					end;
				else
					moGeneralSettings.wtm.temperature.txtColor = 1;
					txtColor = g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[1], true);
				end;
			else
				txtColor = g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[txtColor], true);			
			end;
			setTextAlignment(0);			
			setTextColor(unpack(txtColor));
			renderText(x, bY+diff, optiSize, currentTempTxt);
			setTextAlignment(RenderText.ALIGN_RIGHT);
			setTextColor(unpack(GameInfoDisplay.COLOR.TEXT));		
		elseif moGeneralSettings.wtm.temperature.modus == 4 or moGeneralSettings.wtm.temperature.modus == 5 then
			local txtColor = moGeneralSettings.wtm.temperature.txtColor;
			if moGeneralSettings.wtm.temperature.txtColor == 0 then
				if moGeneralSettings.wtm.temperature.color then
					if currentTemp <= 5 then
						txtcolor = GameInfoDisplay.COLOR.ICON;
					elseif currentTemp > 5 and currentTemp <= 10 then
						txtColor = g_currentMission.hl.getColor("green", true);
					elseif currentTemp > 10 and currentTemp <= 20 then
						txtColor = g_currentMission.hl.getColor("yellow", true);
					elseif currentTemp > 20 and currentTemp <= 30 then
						txtColor = g_currentMission.hl.getColor("darkYellow", true);	
					elseif currentTemp > 30 then
						txtColor = g_currentMission.hl.getColor("red", true);
					end;
				else
					moGeneralSettings.wtm.temperature.txtColor = 1;
					txtColor = g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[1], true);
				end;
			else
				txtColor = g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[txtColor], true);
			end;						
			if (not g_currentMission.hl.runsTimer("15sec", true) and g_currentMission.hl.runsTimer("12sec", true)) or moGeneralSettings.wtm.temperature.modus == 4 then
				setTextAlignment(RenderText.ALIGN_RIGHT);
				setTextColor(unpack(txtColor));
				if moGeneralSettings.wtm.temperature.order == 1 then
					self.temperatureNightText = string.format("%d°", currentTemp);
					renderText(self.temperatureLowTextPositionX, self.temperatureLowTextPositionY, self.temperatureTextSize, self.temperatureNightText);
				else					
					self.temperatureDayText = string.format("%d°", currentTemp);
					renderText(self.temperatureHighTextPositionX, self.temperatureHighTextPositionY, self.temperatureTextSize, self.temperatureDayText);
				end;
			end;
			setTextColor(unpack(GameInfoDisplay.COLOR.TEXT));
		end;
	end;
	function moSetGet.drawDateTxt(self)
		moGeneralSettings.clickAreas.lsWTM["lsDateBox_"] = {};
		local bX, bY, bWidth, bHeight = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.dateBox.overlay);
		local isInArea = false;
		if not moSetGet:disableClickAreas() then
			moSetGet:clickAreasLsWTM( {bX, bX+bWidth, bY, bY+bHeight, whatClick="lsDateBox_"} );
			isInArea = g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack({bX, bX+bWidth, bY, bY+bHeight}));
		end;
		if isInArea then g_currentMission.hl.setBackgroundColor(self.seasonOverlay, g_currentMission.hl.getColor("ls15", true));else g_currentMission.hl.setBackgroundColor(self.seasonOverlay, g_currentMission.hl.getColor("ls22", true));end;		
		if moGeneralSettings.wtm.ingamedate.modus ~= 4 and moGeneralSettings.wtm.ingamedate.defaultY ~= nil then
			self.monthTextPositionY = moGeneralSettings.wtm.ingamedate.defaultY;
			self.monthTextSize = moGeneralSettings.wtm.ingamedate.defaultSize;
		end;
		if moGeneralSettings.wtm.ingamedate.modus == 2 or moGeneralSettings.wtm.ingamedate.modus == 3 or moGeneralSettings.wtm.ingamedate.modus == 4 then			
			local x, y, width, height = g_currentMission.hl.getOverlay(self.seasonOverlay);
			--local txt = g_i18n:getText("statistic_yearsPlayed").. " ".. tostring(self.environment.currentYear);			
			local txt = tostring(moLanguageXml:getTxt("year", nil, "Year")).. " ".. tostring(self.environment.currentYear);			
			local optiSize = self.monthTextSize;
			local diff = 0.003;
			if moGeneralSettings.wtm.ingamedate.modus == 2 then				
				optiSize = g_currentMission.hl.optiHeightSize(y-bY, txt, self.monthTextSize);				
			elseif moGeneralSettings.wtm.ingamedate.modus == 3 then
				optiSize = g_currentMission.hl.optiHeightSize(bY+bHeight-(y+height), txt, self.monthTextSize);
				bY = y+height-diff+0.001;				
			elseif moGeneralSettings.wtm.ingamedate.modus == 4 then
				optiSize = g_currentMission.hl.optiWidthSize(bWidth-(width-0.004), txt, self.monthTextSize);
				if moGeneralSettings.wtm.ingamedate.defaultY == nil then					
					moGeneralSettings.wtm.ingamedate.defaultSize = self.monthTextSize;
					moGeneralSettings.wtm.ingamedate.defaultY = self.monthTextPositionY;
				end;
				if moGeneralSettings.wtm.ingamedate.order == 1 then
					self.monthTextPositionY = y+(height/2);
					bY = self.monthTextPositionY-getTextHeight(optiSize, utf8Substr(txt, 0))-(0.0015);
				else
					bY = y+(height/2)-(0.002);
					self.monthTextPositionY = bY-getTextHeight(self.monthTextSize, utf8Substr(self.monthText, 0))+(diff)+(0.0015);
				end;
			end;							
			setTextAlignment(0);			
			setTextColor(unpack(g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[moGeneralSettings.wtm.ingamedate.txtColor], true)));
			if moGeneralSettings.wtm.ingamedate.modus == 4 then
				renderText(self.monthTextPositionX, bY+diff, optiSize, txt);
			else
				--local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
				renderText(x, bY+diff, optiSize, txt);
			end;
			setTextAlignment(RenderText.ALIGN_LEFT);
			setTextColor(unpack(GameInfoDisplay.COLOR.TEXT));
		end;
	end;
	function moSetGet.updateTime(self)
		local color = GameInfoDisplay.COLOR.ICON;
		if moGeneralSettings.wtm.ingametime.color then
			if self.missionInfo.timeScale > 1 then
				color = g_currentMission.hl.getColor("orangeRed", true);
			elseif self.missionInfo.timeScale < 1 then
				color = g_currentMission.hl.getColor("yellow", true);
			end;
		end;
		g_currentMission.hl.setBackgroundColor(g_currentMission.hud.gameInfoDisplay.timeScaleArrow.overlay, color);
		g_currentMission.hl.setBackgroundColor(g_currentMission.hud.gameInfoDisplay.timeScaleArrowFast.overlay, color);		
	end;
	function moSetGet.drawTimeText(self)
		moGeneralSettings.clickAreas.lsWTM["lsTimeBox_"] = {};
		local bX, bY, bWidth, bHeight = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.timeBox.overlay);
		local isInArea = false;
		if not moSetGet:disableClickAreas() then
			moSetGet:clickAreasLsWTM( {bX, bX+bWidth, bY, bY+bHeight, whatClick="lsTimeBox_"} );
			isInArea = g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack({bX, bX+bWidth, bY, bY+bHeight}));
		end;
		if isInArea then			
			g_currentMission.hl.setBackgroundColor(self.clockHandLarge.overlay, g_currentMission.hl.getColor("ls15", true));
			g_currentMission.hl.setBackgroundColor(self.clockHandSmall.overlay, g_currentMission.hl.getColor("ls15", true));
			g_currentMission.hl.setBackgroundColor(self.clockElement.overlay, g_currentMission.hl.getColor("ls15", true));
		else 
			g_currentMission.hl.setBackgroundColor(self.clockElement.overlay, g_currentMission.hl.getColor("ls22", true));
			g_currentMission.hl.setBackgroundColor(self.clockHandLarge.overlay, g_currentMission.hl.getColor("ls22", true));
			g_currentMission.hl.setBackgroundColor(self.clockHandSmall.overlay, g_currentMission.hl.getColor("ls22", true));
		end;		
		if moGeneralSettings.wtm.ingametime.modus == 2 or moGeneralSettings.wtm.ingametime.modus == 3 then
			local x, y, width, height = g_currentMission.hl.getOverlay(self.clockElement.overlay);			
			local txt = "";
			local playdays = g_i18n:getText("ui_day");
			local playdaysLarge = moLanguageXml:getTxt("playdays", nil, playdays)
			playdays = playdays.. " ".. tostring(g_currentMission.environment.currentDay);
			playdaysLarge = playdaysLarge.. " ".. tostring(g_currentMission.environment.currentDay);
			local day = moDraw.time:getIngameDay();
			local dayLarge = moDraw.time:getIngameDay(true);
			if not moGeneralSettings.wtm.ingametime.day then day = "";end;
			if not moGeneralSettings.wtm.ingametime.playdays then playdays = "";end;
			if not moGeneralSettings.wtm.ingametime.day and not moGeneralSettings.wtm.ingametime.playdays then moGeneralSettings.wtm.ingametime.modus = 1;return;end;
			if day:len() > 0 then 
				if not moGeneralSettings.wtm.ingametime.playdays then txt = tostring(dayLarge);else	txt = tostring(day);end;
			end;
			if not moGeneralSettings.wtm.ingametime.day then playdays = playdaysLarge;end; 
			if playdays:len() > 0 then --ui_mpPlaytime
				local separator = " / ";
				if txt:len() == 0 then separator = "";end;
				if moGeneralSettings.wtm.ingametime.order == 1 then					
					txt = txt.. separator.. tostring(playdays);
				else
					txt = tostring(playdays).. separator.. txt;
				end;
			end;						
			local optiSize = self.timeTextSize;
			local diff = 0.003;
			if moGeneralSettings.wtm.ingametime.modus == 2 then
				optiSize = g_currentMission.hl.optiHeightSize(bY+bHeight-(y+height), txt, self.timeTextSize);				
			else
				optiSize = g_currentMission.hl.optiHeightSize(y-bY, txt, self.timeTextSize);
				bY = y+height-diff+0.001;
			end;
			local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
			if txtWidth > bWidth then optiSize = g_currentMission.hl.optiWidthSize(bWidth-diff, txt, optiSize);end;
			setTextAlignment(0);			
			setTextColor(unpack(g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[moGeneralSettings.wtm.ingametime.txtColor], true)));
			renderText(x, bY+diff, optiSize, txt);			
			setTextAlignment(RenderText.ALIGN_LEFT);
			setTextColor(unpack(GameInfoDisplay.COLOR.TEXT));
		end;	
	end;
	function moSetGet.drawMoneyText(self)
		moGeneralSettings.clickAreas.lsWTM["lsMoneyBox_"] = {};
		local bX, bY, bWidth, bHeight = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.moneyBox.overlay);
		local isInArea = false;
		if not moSetGet:disableClickAreas() then
			moSetGet:clickAreasLsWTM( {bX, bX+bWidth, bY, bY+bHeight, whatClick="lsMoneyBox_"} );
			isInArea = g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack({bX, bX+bWidth, bY, bY+bHeight}));
		end;			
		if isInArea then g_currentMission.hl.setBackgroundColor(self.moneyIconOverlay, g_currentMission.hl.getColor("ls15", true));else g_currentMission.hl.setBackgroundColor(self.moneyIconOverlay, g_currentMission.hl.getColor("ls22", true));end;
		if moGeneralSettings.wtm.money.modus == 2 or moGeneralSettings.wtm.money.modus == 3 then			
			local x, y, width, height = g_currentMission.hl.getOverlay(self.moneyIconOverlay);			
			local txt = "";
			local year = getDate("%Y");local day = getDate("%d");local month = getDate("%m");
			local realTime = g_currentMission.hl.getRealTime(true, true, moGeneralSettings.timeFormat == 12);
			local realDay = moDraw.time:getRealDay(false);
			local realDayLarge = moDraw.time:getRealDay(true);
			if not moGeneralSettings.wtm.realdata.date then day = "";month = "";year = "";end;
			if not moGeneralSettings.wtm.realdata.time then realTime = "";end;
			if not moGeneralSettings.wtm.realdata.day then realDay = "";realDayLarge = "";end;
			if not moGeneralSettings.wtm.realdata.date and not moGeneralSettings.wtm.realdata.time and not moGeneralSettings.wtm.realdata.day then moGeneralSettings.wtm.money.modus = 1;return;end;			
			if realDay:len() > 0 then txt = tostring(realDay);end;
			if realTime:len() > 0 then
				if txt:len() == 0 then txt = tostring(realTime);else txt = txt.. " ".. tostring(realTime);end;
			end;
			if year:len() > 0 then
				if moGeneralSettings.wtm.realdata.order == 1 then
					if txt:len() == 0 then txt = tostring(day).. ".".. tostring(month).. ".".. tostring(year);else txt = txt.. " / ".. tostring(day).. ".".. tostring(month).. ".".. tostring(year);end;
				else
					if txt:len() == 0 then txt = tostring(day).. ".".. tostring(month).. ".".. tostring(year);else txt = tostring(day).. ".".. tostring(month).. ".".. tostring(year).. " / ".. txt;end;
				end;
			end;					
			local optiSize = self.moneyTextSize;
			local diff = 0.003;
			if moGeneralSettings.wtm.money.modus == 2 then
				optiSize = g_currentMission.hl.optiHeightSize(bY+bHeight-(y+height), txt, self.moneyTextSize);
				optiSize = g_currentMission.hl.optiWidthSize(bWidth, txt, optiSize);
			else
				optiSize = g_currentMission.hl.optiHeightSize(y-bY, txt, self.moneyTextSize);
				optiSize = g_currentMission.hl.optiWidthSize(bWidth, txt, optiSize);
				bY = y+height-diff+0.001;
			end;			
			setTextAlignment(0);			
			setTextColor(unpack(g_currentMission.hl.getColor(moGeneralSettings.wtm.acceptsTxtColor[moGeneralSettings.wtm.realdata.txtColor], true)));
			renderText(x, bY+diff, optiSize, txt);
			setTextAlignment(RenderText.ALIGN_CENTER);
			setTextColor(unpack(GameInfoDisplay.COLOR.ICON));			
		end;		
	end;
	function moSetGet.updateWeather(self)
		moGeneralSettings.clickAreas.lsWTM["lsWeatherBox_"] = {};
		local bX, bY, bWidth, bHeight = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.weatherBox.overlay);
		local isInArea = false;
		if not moSetGet:disableClickAreas() then
			moSetGet:clickAreasLsWTM( {bX, bX+bWidth, bY, bY+bHeight, whatClick="lsWeatherBox_"} );
			isInArea = g_currentMission.hl.mouseIsInArea(MultiOverlayV4.mouseCursor.posX, MultiOverlayV4.mouseCursor.posY, unpack({bX, bX+bWidth, bY, bY+bHeight}));
		end;
		if isInArea then
			for weatherType, icon in pairs(self.weatherTypeIcons) do
				local isCurrent = weatherType == self.currentWeather;
				if isCurrent then
					g_currentMission.hl.setBackgroundColor(icon.overlay, g_currentMission.hl.getColor("ls15", true));
					break;
				end;
			end;
		else
			for weatherType, icon in pairs(self.weatherTypeIcons) do
				local isCurrent = weatherType == self.currentWeather;
				if isCurrent then
					g_currentMission.hl.setBackgroundColor(icon.overlay, g_currentMission.hl.getColor("ls22", true));
					break;
				end;
			end;
		end;
	end;
	GameInfoDisplay.updateWeather = Utils.appendedFunction(GameInfoDisplay.updateWeather, moSetGet.updateWeather);
	GameInfoDisplay.drawMoneyText = Utils.appendedFunction(GameInfoDisplay.drawMoneyText, moSetGet.drawMoneyText);
	GameInfoDisplay.drawTimeText = Utils.appendedFunction(GameInfoDisplay.drawTimeText, moSetGet.drawTimeText);
	GameInfoDisplay.updateTime = Utils.appendedFunction(GameInfoDisplay.updateTime, moSetGet.updateTime);
	GameInfoDisplay.drawDateText = Utils.appendedFunction(GameInfoDisplay.drawDateText, moSetGet.drawDateTxt);
	GameInfoDisplay.drawTemperatureText = Utils.appendedFunction(GameInfoDisplay.drawTemperatureText, moSetGet.drawTemperatureTxt);
	GameInfoDisplay.updateTemperature = Utils.appendedFunction(GameInfoDisplay.updateTemperature, moSetGet.updateTemperature);
	function moSetGet:clickAreasLsWTM(args)
		moGeneralSettings.clickAreas.lsWTM[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
			whatClick=args.whatClick;
		};
	end;
end;

function moSetGet:refreshWtmState()
	g_currentMission.hud.gameInfoDisplay:setWeatherVisible(moGeneralSettings.wtm.weather.show);
	g_currentMission.hud.gameInfoDisplay:setTemperatureVisible(moGeneralSettings.wtm.temperature.show);
	g_currentMission.hud.gameInfoDisplay:setDateVisible(moGeneralSettings.wtm.ingamedate.show);
	g_currentMission.hud.gameInfoDisplay:setTimeVisible(moGeneralSettings.wtm.ingametime.show);
	g_currentMission.hud.gameInfoDisplay:setMoneyVisible(moGeneralSettings.wtm.money.show);
end;

function moSetGet:loadDefaultWtmState()
	moGeneralSettings.wtm.weather.show = g_currentMission.hud.gameInfoDisplay.showWeather;
	moGeneralSettings.wtm.temperature.show = g_currentMission.hud.gameInfoDisplay.showTemperature;
	moGeneralSettings.wtm.ingamedate.show = g_currentMission.hud.gameInfoDisplay.showDate;
	moGeneralSettings.wtm.ingametime.show = g_currentMission.hud.gameInfoDisplay.showTime;
	moGeneralSettings.wtm.money.show = g_currentMission.hud.gameInfoDisplay.showMoney;
end;

function moSetGet:getWtmState(typ)
	if g_currentMission.hud == nil then
		if typ == "ShowWeather" then
			return moGeneralSettings.wtm.weather.show;
		elseif typ == "ShowTemperature" then
			return moGeneralSettings.wtm.temperature.show;
		elseif typ == "ShowIngameDate" then
			return moGeneralSettings.wtm.ingamedate.show;
		elseif typ == "ShowIngameTime" then
			return moGeneralSettings.wtm.ingametime.show;
		elseif typ == "ShowMoney" then
			return moGeneralSettings.wtm.money.show;
		end;
	else
		if typ == "ShowWeather" then
			return g_currentMission.hud.gameInfoDisplay.showWeather;
		elseif typ == "ShowTemperature" then
			return g_currentMission.hud.gameInfoDisplay.showTemperature;
		elseif typ == "ShowIngameDate" then
			return g_currentMission.hud.gameInfoDisplay.showDate;
		elseif typ == "ShowIngameTime" then
			return g_currentMission.hud.gameInfoDisplay.showTime;
		elseif typ == "ShowMoney" then
			return g_currentMission.hud.gameInfoDisplay.showMoney;
		end;
	end;
	return true;
end;

function moSetGet:getIsRaining(rainScale)
	return rainScale > 0.05;
end

function moSetGet:getRainScale(state)
	return g_currentMission.environment.weather:getRainFallScale(state);
end;

function moSetGet:getSnowScale()
	local rainScale = moSetGet:getRainScale(true);
	local snowScale = moSetGet:getRainScale(false) - rainFallScale;
	return snowScale;
end;

function moSetGet:getCloudData()
	local cloudData = g_currentMission.environment.weather.cloudUpdater:getCurrentValues();
	return cloudData.type;
end;

function moSetGet:getFogData()
	return g_currentMission.environment.weather.fogUpdater:getCurrentValues();
end;

function moSetGet:getWeatherTypeAtTime(hour) -- 12 or 24
	local env = g_currentMission.environment;
	local dayTime = env.weather.forecast.owner.owner.dayTime + hour * 60 * 60 * 1000;
	local day = env.weather.forecast.owner.owner.currentMonotonicDay;	
	if #env.weather.forecastItems == 0 then
		return WeatherType.SUN;
	end;
	local instance = env.weather.forecastItems[1];
	for _, object in ipairs(env.weather.forecastItems) do
		if object.startDay < day or object.startDay == day and object.startDayTime < dayTime then
			instance = object;
		else
			break;
		end;
	end;
	local object = env.weather:getWeatherObjectByIndex(instance.season, instance.objectIndex);
	return object.weatherType.index;
end;

function moSetGet:getHourlyForecast(hours) -- 1-24
	local isWeatherStation = g_currentMission.placeableSystem:getHasWeatherStation(g_currentMission:getFarmId());
	local env = g_currentMission.environment;
	local forecastWeather = {};
	for w=1, hours do
		local forecastInfo = env.weather.forecast:getHourlyForecast(w);
		if forecastInfo ~= nil then
			local timeHours = math.floor(forecastInfo.time / 3600000 + 0.0001);			
			forecastInfo.formatTime = string.format("%02d:00", timeHours);
			local period = g_currentMission.environment:getPeriodFromDay(forecastInfo.day);
			local dayInPeriod = g_currentMission.environment:getDayInPeriodFromDay(forecastInfo.day);
			forecastInfo.dayPeriod = g_i18n:formatDayInPeriod(dayInPeriod, period, false);
			table.insert(forecastWeather, forecastInfo);
		end;
	end;
	return forecastWeather;
end;

function moSetGet:playerHandTool()
	if Player.MAX_PICKABLE_OBJECT_DISTANCE < 15 then Player.MAX_PICKABLE_OBJECT_DISTANCE = 15;end;
	oldPlayerStateCycleHandtool = PlayerStateCycleHandtool.isAvailable;
	PlayerStateCycleHandtool.isAvailable = function (self)
		local isOkay, result = pcall(oldPlayerStateCycleHandtool, self);
		if isOkay and self ~= nil then
			if not moGeneralSettings.other.handToolsSwitch or g_currentMission.hl.isMouseCursor then return false;end;			
			return result;
		end;
	end;	
end;

function moSetGet:vehicleZoom() 
	oldVehicleCamera = VehicleCamera.zoomSmoothly;
	VehicleCamera.zoomSmoothly = function(self, offset)
		local zoomTarget = self.zoomTarget;
		local isOkay, result = pcall(oldVehicleCamera, self, offset)
		if isOkay and self ~= nil then
			if not g_currentMission.hl.isMouseCursor then				
				return offset;			
			else				
				self.zoomTarget = zoomTarget;				
			end;
		end;
	end;
end;

function moSetGet:updateTextTickerPos(pos)
	if moGeneralSettings.textTicker.isOn and g_currentMission.hl.textTicker.mods["MultiOverlayV4"] ~= nil then
		if moGeneralSettings.textTicker.pos == 1 or moGeneralSettings.textTicker.pos == 2 or moGeneralSettings.textTicker.pos == 3 or moGeneralSettings.textTicker.pos == 4 then
			local x1, y1, w1, h1 = g_currentMission.hl.getOverlay(g_currentMission.hud.gameInfoDisplay.backgroundOverlay.overlay);
			local textTicker = g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value;
			if textTicker.ePosX ~= x1 or textTicker.width ~= w1 then
				g_currentMission.hl.setOverlay(g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"], x1, nil, w1);
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.ePosX = x1;g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.width = w1;
			end;
		elseif moGeneralSettings.textTicker.pos == 5 then
			if not moGeneralSettings.pdaType.light or moSetGetOverlaysLight.default.pda[1] == nil then return;end;
			local x1, y1, w1, h1 = g_currentMission.hl.getOverlay(moSetGetOverlaysLight.default.pda[1].icon.background);
			local textTicker = g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value;
			if textTicker.ePosX ~= x1 or textTicker.width ~= w1 then
				g_currentMission.hl.setOverlay(g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"], x1, nil, w1);
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.ePosX = x1;g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.width = w1;
			end;
		elseif moGeneralSettings.textTicker.pos == 7 then
			if moSetGetOverlays.pda["weatherTimeMoneyPda_"] == nil then return;end;
			if moSetGetOverlays.pda["weatherTimeMoneyPda_"].isOpen then
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].isHidden = false;
				local pdaTable = moSetGetOverlays.pda["weatherTimeMoneyPda_"];
				local y1 = pdaTable.posY[pdaTable.view.isModus];
				local x1 = pdaTable.posX[pdaTable.view.isModus];
				local w1 = pdaTable.width[pdaTable.view.isModus];
				local h1 = pdaTable.height[pdaTable.view.isModus];
				local frameHeight = moSetGetOverlays.buttonGfxHeight1*pdaTable.frameZoomOutIn;				
				local textTicker = g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value;
				if x1+w1 < 0.99 then 
					g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong (Position corrupt) !!\nneeds MOH WTM Hud on the edge, right", maxLine=2, txtBold=true, duration=5, warning=true} );
					moSetGet:setTextTickerOnOff(1, true, true);
					return;
				end;
				if textTicker.ePosX ~= x1 or textTicker.posY ~= y1-h1-frameHeight or textTicker.aPosX ~= x1+w1 or textTicker.width ~= w1 or textTicker.height ~= frameHeight then
					local otiSize = textTicker.txtSize;
					local txtHeight = textTicker.txtHeight;
					if textTicker.height ~= frameHeight then optiSize = g_currentMission.hl.optiHeightSize(frameHeight, "Ä", 0.015);txtHeight = getTextHeight(optiSize, "Ä");end;
					g_currentMission.hl.setOverlay(g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"], x1, y1-h1-frameHeight, w1, frameHeight);
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.ePosX = x1;
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.width = w1;
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.aPosX = x1+w1;
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.posY = y1-h1-frameHeight;
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.txtSize = optiSize;
					g_currentMission.hl.textTicker.mods["MultiOverlayV4"].value.txtHeight = txtHeight;
				end;
			else
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].isHidden = true;
			end;		
		end;
	end;
end;

function moSetGet:setTextTickerOnOff(pos, fail, change)	
	if moGeneralSettings.textTicker.isOn then
		--if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] ~= nil then return;end;
		if fail ~= nil and fail then moGeneralSettings.textTicker.pos = 1;end;
		local firstStart = pos == nil;
		if pos ~= nil then
			if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] ~= nil then
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"]:delete();
				g_currentMission.hl.textTicker.mods["MultiOverlayV4"] = nil;
			end;
		else
			pos = moGeneralSettings.textTicker.pos;
		end;		
		local value = moDraw.textTicker:getPos(pos); --aPosX, ePosX, posY, width, height, txtSize, txtHeight
		if (value == nil or value[3] == nil) and (change == nil or not change) then moSetGet:setTextTickerOnOff(1, true, true);end;
		if (value == nil or value[3] == nil) and change then 
			moGeneralSettings.textTicker.isOn = false;
			moGeneralSettings.textTicker.pos = 1;
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong (Position corrupt) !!", txtBold=true, duration=5, warning=true} );
			return;
		end;		
		local isOkay = g_currentMission.hl.generateTextTicker( {modName="MultiOverlayV4", aPosX=value[1], ePosX=value[2], posY=value[3], width=value[4], height=value[5], txtSize=value[6], txtHeight=value[7]} );
		if not isOkay then			
			moGeneralSettings.textTicker.isOn = false;
			moGeneralSettings.textTicker.pos = 1;
			g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong (Generate Text Ticker) !!", txtBold=true, duration=5, warning=true} );
		else
			if pos == 2 or pos == 4 or pos == 7 then g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].visible = false;else g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].visible = true;end;
			if pos == 7 then g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].isHidden = false;else g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"].isHidden = nil;end;
			if not firstStart then	g_currentMission.hl.addTextTicker( {modName="MultiOverlayV4", txt="Here Position ".. tostring(moGeneralSettings.textTicker.pos), repeatable=0, txtColor="ls22"} );end;
		end;		
	else
		moGeneralSettings.textTicker.pos = 1;
		if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] == nil then return;end;
		g_currentMission.hl.textTicker.mods["MultiOverlayV4"].overlay["textTicker"]:delete();
		g_currentMission.hl.textTicker.mods["MultiOverlayV4"] = nil;
	end;			
end;

function moSetGet:updateTextTickerOther()
	if not moGeneralSettings.textTicker.isOn then return;end;
	if g_currentMission.hl.textTicker.mods["MultiOverlayV4"] == nil then return;end;
	if moGeneralSettings.playTime[1] == -1 then 
		local user = g_currentMission.userManager:getUserByUserId(g_currentMission.player.userId)
		local playerName = "";
		if user ~= nil then
            local userName = Utils.getNoNil(user:getNickname(),nil);
			if userName ~= nil then playerName = " ".. tostring(userName).. " ";end;
		end;
		local isRealTime = tonumber(g_currentMission.hl.getRealTime(true));
		if isRealTime == 24 then isRealTime = 0;end;
		moGeneralSettings.playTime[1] = isRealTime;moGeneralSettings.playTime[2]=moGeneralSettings.playTime[1]+1;
		g_currentMission.hl.addTextTicker( {modName="MultiOverlayV4", txt=tostring(moLanguageXml:randomTextTickerTxt(playerName)), repeatable=0, txtColor="ls22"} );		
		return;
	end;
	local isRealTime = tonumber(g_currentMission.hl.getRealTime(true));
	if isRealTime == 24 then isRealTime = 0;end;
	if isRealTime == moGeneralSettings.playTime[2] then
		local moreTxt = "";
		if moGeneralSettings.playTime[2]-moGeneralSettings.playTime[1] >= 2 then
			local user = g_currentMission.userManager:getUserByUserId(g_currentMission.player.userId)
			local playerName = "";
			if user ~= nil then
				local userName = Utils.getNoNil(user:getNickname(),nil);
				if userName ~= nil then playerName = " ".. tostring(userName).. " ";end;
			end;
			if playerName:len() > 0 then
				moreTxt = " / "..playerName.. "... ".. g_i18n:getText("achievement_descHorseRiding");
			else
				moreTxt = " / ".. g_i18n:getText("achievement_descHorseRiding");
			end;
		end;
		moGeneralSettings.textTicker.txt = g_i18n:getText("achievement_descPlayTime").. " ".. g_i18n:getText("ui_mpPlaytime").. ": ".. tostring(string.format(g_i18n:getText("shop_saleRemaingHoursValue"), moGeneralSettings.playTime[2]-moGeneralSettings.playTime[1])).. tostring(moreTxt);		
		moGeneralSettings.playTime[2] = isRealTime+1;
	end;
end;