moMouseKeyEventsLight = {};

function moMouseKeyEventsLight:setMouse(posX, posY, isDown, isUp, button, clickAreaTable)
	if button == Input.MOUSE_BUTTON_LEFT then
		moMouseKeyEventsLight:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_MIDDLE then
		moMouseKeyEventsLight:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_RIGHT then
		moMouseKeyEventsLight:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_UP then
		moMouseKeyEventsLight:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable);
	elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN then
		moMouseKeyEventsLight:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable);
	end;		
end;

function moMouseKeyEventsLight:buttonLeft(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonLeft_" and isDown then
		if moSetGetOverlaysLight.default.pda[clickAreaTable.pda+1] == nil and clickAreaTable.pda == 1 then --disabled more slave pda, later idee for 2 and more
			guiDialog:generateSlavePdaTypeLight(2);
		elseif moSetGetOverlaysLight.default.pda[clickAreaTable.pda+1] ~= nil then
			moSetGetOverlaysLight.default.pda[clickAreaTable.pda+1].view[1] = not moSetGetOverlaysLight.default.pda[clickAreaTable.pda+1].view[1];		
		else
			g_currentMission.hl.addTextDisplay( {txt="Button for this PDA Not Active/wait update", txtBold=true, duration=3, warning=true} );
		end;		
	elseif clickAreaTable.whereClick == "buttonSetting_" and isDown then
		if g_currentMission.hlGui.menue.isOpen and not moSetGetOverlaysLight.default.setting.on then
			g_currentMission.hlGui.setGet:setClose();
		end;
		moSetGetOverlaysLight.default.setting.selectApp = 0;
		if not moSetGetOverlaysLight.default.setting.on then
			moSetGetOverlaysLight.default.setting.selectPda = clickAreaTable.pda;
			moSetGetOverlaysLight.default.setting.on = true;		
		elseif moSetGetOverlaysLight.default.setting.on and moSetGetOverlaysLight.default.setting.selectPda == clickAreaTable.pda then
			moSetGetOverlaysLight.default.setting.on = false;
			moSetGetOverlaysLight.default.setting.selectPda = 0;
		elseif moSetGetOverlaysLight.default.setting.on and moSetGetOverlaysLight.default.setting.selectPda ~= clickAreaTable.pda then
			moSetGetOverlaysLight.default.setting.selectPda = clickAreaTable.pda;	
		end;		
		return;
	elseif clickAreaTable.whereClick == "appIcon_" and isDown then
		if clickAreaTable.pda ~= nil and clickAreaTable.app ~= nil then
			local pdaTable = moSetGetOverlaysLight.default.pda[clickAreaTable.pda];
			if pdaTable ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
				local selectApp = pdaTable.app[clickAreaTable.app];
				if selectApp ~= nil and selectApp.onAction ~= nil and type(selectApp.onAction) == "function" then
					selectApp.onAction( {pdaTable=pdaTable, pda=clickAreaTable.pda, app=clickAreaTable.app, mouseClick="MOUSE_BUTTON_LEFT"} );
				end;
			end;
		end;		
	end;
end;

function moMouseKeyEventsLight:buttonMiddle(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "appIcon_" and isDown then
		if clickAreaTable.pda ~= nil and clickAreaTable.app ~= nil then
			local pdaTable = moSetGetOverlaysLight.default.pda[clickAreaTable.pda];
			if pdaTable ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then				
				local selectApp = pdaTable.app[clickAreaTable.app];
				if selectApp ~= nil and selectApp.onAction ~= nil and type(selectApp.onAction) == "function" then
					selectApp.onAction( {pdaTable=pdaTable, pda=clickAreaTable.pda, app=clickAreaTable.app, mouseClick="MOUSE_BUTTON_MIDDLE"} );
				end;
			end;
		end;		
	end;
end;

function moMouseKeyEventsLight:buttonRight(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whereClick == "buttonLeft_" and isDown then		
		local dummyPda = moDraw.pda:getOpen("dummyPda_");
		if type(dummyPda) == "boolean" then
			if not dummyPda then moDraw.pda:setOpen("dummyPda_");else moDraw.pda:setClose("dummyPda_");end;
		end;
	elseif clickAreaTable.whereClick == "buttonSetting_" and isDown then
		if g_currentMission.hlGui.menue.isOpen and not moSetGetOverlaysLight.default.setting.on then
			g_currentMission.hlGui.setGet:setClose();
		else
			g_currentMission.hlGui.setGet:setOpen("MultiOverlayV4", MultiOverlayV4.hlGui.page["GlobalSetting"], MultiOverlayV4.hlGui.side["GlobalSetting"]);		
		end;
	elseif clickAreaTable.whereClick == "appIcon_" and isDown then		
		if clickAreaTable.pda ~= nil and clickAreaTable.app ~= nil then
			local pdaTable = moSetGetOverlaysLight.default.pda[clickAreaTable.pda];
			if pdaTable ~= nil and pdaTable.app[clickAreaTable.app] ~= nil then
				local selectApp = pdaTable.app[clickAreaTable.app];
				if selectApp ~= nil and selectApp.onAction ~= nil and type(selectApp.onAction) == "function" then
					selectApp.onAction( {pdaTable=pdaTable, pda=clickAreaTable.pda, app=clickAreaTable.app, mouseClick="MOUSE_BUTTON_RIGHT"} );
				end;
			end;
		end;		
	end;
end;

function moMouseKeyEventsLight:buttonWheelUp(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "scrollUpPda" and isDown then		
		moSetGetLight:setPdaBounds(clickAreaTable.pda, true);
		return;		
	end;
end;

function moMouseKeyEventsLight:buttonWheelDown(posX, posY, isDown, isUp, button, clickAreaTable)
	if clickAreaTable.whatClick == "scrollDownPda" and isDown then		
		moSetGetLight:setPdaBounds(clickAreaTable.pda, false);
		return;
	end;
end;