moSetGetLight = {};

function moSetGetLight:autoGenerateSlotPda(pda, app)
	local selectApp = moSetGetOverlaysLight.default.pda[pda].app[app];
	if selectApp.typ == "pda" then
		moSetGetPda:generatePda(selectApp.name, string.gsub(selectApp.name, "Pda_", ""):upper(), false, false, true);
		MultiOverlayV4:setUnSave();
	elseif selectApp.typ == "slot" then
		local name = string.gsub(selectApp.name, "Slot_", "");
		local funcName = string.gsub(selectApp.name, "_", "");
		if moAutoGenerateSlot[funcName] ~= nil and type(moAutoGenerateSlot[funcName]) == "function" then
			moAutoGenerateSlot[funcName](false);
			if selectApp.name == "mapMissionsSlot_" or selectApp.name == "mapFarmlandsSlot_" or selectApp.name == "fillTypeAmountPriceSlot_" or selectApp.name == "teleportPointsSlot_" then
				moSetGetLight:setPdaOpenCloseApp(moSetGetOverlaysLight.default.pda[pda], app);
			end;
			MultiOverlayV4:setUnSave();
		else
			moSetGetSlot:generateSlot(selectApp.name, string.gsub(selectApp.name, "Slot_", ""):upper(), false, false, true);
			MultiOverlayV4:setUnSave();
		end;
	else
		g_currentMission.hl.addTextDisplay( {txt="!! Upps something went wrong !!", txtBold=true, duration=5, warning=true} );
	end;
end;

function moSetGetLight:setPdaOpenCloseApp(pdaTable, app)
	local selectApp = pdaTable.app[app];
	if not selectApp.view then return true;end;	
	if moSetGetOverlays[selectApp.typ] ~= nil and moSetGetOverlays[selectApp.typ][selectApp.name] ~= nil then
		if moSetGetOverlays[selectApp.typ][selectApp.name].isOpen then
			moDraw[selectApp.typ]:setClose(selectApp.name);			
			return true;
		end;
	
		for a=1, #pdaTable.app do
			if a ~= app then
				if pdaTable.app[a].view and pdaTable.app[a].autoClose then
					if moSetGetOverlays[pdaTable.app[a].typ] ~= nil and moSetGetOverlays[pdaTable.app[a].typ][pdaTable.app[a].name] ~= nil then
						if moSetGetOverlays[pdaTable.app[a].typ][pdaTable.app[a].name].isOpen then
							moDraw[pdaTable.app[a].typ]:setClose(pdaTable.app[a].name);
						end;
					end;
				end;
			end;
		end;
		moDraw[selectApp.typ]:setOpen(selectApp.name);
		return true;
	end;
	return false;	
end;

function moSetGetLight:setPdaCmdApp(selectApp, mouseClick)	
	if not selectApp.view then return nil;end;
	if selectApp.typ == "cmd" then		
		if selectApp.name ~= nil and MultiOverlayV4.cmd[selectApp.name] ~= nil then
			local orgCmd = MultiOverlayV4.cmd[selectApp.name];
			if orgCmd.actionCallback ~= nil and type(orgCmd.actionCallback) == "function" and (orgCmd.typ[1] == "action_" or orgCmd.typ[1] == "actionOutput_") then
				if (mouseClick == "MOUSE_BUTTON_LEFT" and orgCmd.mouseClickAccepts[1]) or (mouseClick == "MOUSE_BUTTON_MIDDLE" and orgCmd.mouseClickAccepts[2]) or (mouseClick == "MOUSE_BUTTON_RIGHT" and orgCmd.mouseClickAccepts[3]) then
					local profil = moGeneralSettings.profile.select;
					orgCmd.actionCallback({cmdTable=orgCmd, mouseClick=mouseClick});				
					if selectApp.name == "MultiOverlayV4_cmd_action_switchProfile_" and profil ~= moGeneralSettings.profile.select then
						moSetGetOverlaysLight:searchMohOverlapHuds();					
					end;
					return true;
				end;
			end;		
		end;
		return false;
	end;
	return nil;
end;

function moSetGetLight:setPdaBounds(pda, up)
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	local maxViewApps = moSetGetOverlaysLight:getPdaMaxViewApps(pda);
	local viewApps = moSetGetLight:getPdaViewApps(pda);	
	local maxBoundsLine = math.ceil(#viewApps/maxViewApps);
	if maxBoundsLine == 0 or #viewApps <= maxViewApps then maxBoundsLine = 1;end;
	function setPdaViewIconsByBounds()
		local bounds1 = pdaTable.bounds.line[pdaTable.bounds.isLine][1];
		local bounds2 = pdaTable.bounds.line[pdaTable.bounds.isLine][2];
		pdaTable.appIconView = {};
		for app=bounds1, #viewApps do		
			pdaTable.appIconView[#pdaTable.appIconView+1] = viewApps[app];			
			if #pdaTable.appIconView >= maxViewApps then break;end;
		end;
	end;	
	function calculateLineBounds()
		pdaTable.bounds.lineMax = maxBoundsLine;
		pdaTable.bounds.line = {};
		for a=1, maxBoundsLine do
			pdaTable.bounds.line[a] = {(maxViewApps*a)-(maxViewApps)+1,maxViewApps*a};			
		end;
		pdaTable.bounds.maxViewApps = maxViewApps;
		pdaTable.bounds.viewApps = #viewApps;
		pdaTable.bounds.isLine = 1;		
		--if pda ~= 1 and up == nil then moSetGetOverlaysLight:updateSlavePda(true);end;
		setPdaViewIconsByBounds();
		up = nil;
	end;
	--moGeneralSettings.testString[1] = "Pda: ".. tostring(pda).. " / maxViewApps: ".. tostring(maxViewApps).. " / viewApps: ".. tostring(#viewApps);
	if up == nil or pdaTable.bounds.line[1] == nil or pdaTable.bounds.lineMax ~= maxBoundsLine or pdaTable.bounds.maxViewApps ~= maxViewApps or pdaTable.bounds.viewApps ~= #viewApps then calculateLineBounds();end;
	if up == nil then return;end;	
	if up then
		if pdaTable.bounds.isLine == 1 then pdaTable.bounds.isLine = #pdaTable.bounds.line;else pdaTable.bounds.isLine = pdaTable.bounds.isLine-1;end;
	else
		if pdaTable.bounds.isLine == #pdaTable.bounds.line then pdaTable.bounds.isLine = 1;else pdaTable.bounds.isLine = pdaTable.bounds.isLine+1;end;		
	end;
	setPdaViewIconsByBounds();	
end;

function moSetGetLight:getPdaViewApps(pda)
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	local viewApps = {};	
	for app=1, #pdaTable.app do
		if pdaTable.app[app].view then 
			viewApps[#viewApps+1] = app;			
		end;
	end;
	return viewApps;
end;

function moSetGetLight:setNewAppOrder(up)
	if moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda] == nil then return false;end;
	if moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda].appIcon == nil then return false;end;
	local pdaTable = moSetGetOverlaysLight.default.pda[moSetGetOverlaysLight.default.setting.selectPda];
	local selectApp = moSetGetOverlaysLight.default.setting.selectApp;
	local oldAppIcon = pdaTable.appIcon[selectApp];
	local oldApp = pdaTable.app[selectApp];
	local newPos = 0;
	if up then
		newPos = selectApp+1;
		if pdaTable.appIcon[newPos] == nil then newPos = 1;end;
	else
		newPos = selectApp-1;
		if newPos <= 0 then newPos = #pdaTable.appIcon-1;end;
	end;
	table.remove(pdaTable.appIcon, selectApp);
	table.remove(pdaTable.app, selectApp);
	table.insert(pdaTable.appIcon, newPos, oldAppIcon);
	table.insert(pdaTable.app, newPos, oldApp);
	moSetGetOverlaysLight.default.setting.selectApp = newPos;
	moSetGetLight:setPdaBounds(moSetGetOverlaysLight.default.setting.selectPda);
	return true;	
end;

function moSetGetLight.onActionSlot(args) --Slot App Icons Callback
	if args == nil or args.pdaTable == nil or args.app == nil or args.mouseClick == nil or args.pda == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" then 
		local app = args.pdaTable.app[args.app];
		if app.typ == "slot" then
			local foundSlotPda = moSetGetLight:setPdaOpenCloseApp(args.pdaTable, args.app);
			if not foundSlotPda then
				guiDialog:autoGenerateSlotPda(args.pda, args.app);
			end;
		end;		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then
		local app = args.pdaTable.app[args.app];
		if app.typ == "slot" then
			if app.name == "vehicleStateSlot_" then
				moModule:showInGameMenuFrame("pageGarageOverview", 0, true, false, 0);				
			elseif app.name == "mapMissionsSlot_" then
				moModule:showInGameMenuFrame("pageContracts", 0, true, false, 0);	
			elseif app.name == "mapFarmlandsSlot_" then
				moModule:showInGameMenuFrame("pageMapOverview", 0, true, true, 0);	
			elseif app.name == "fillTypeAmountPriceSlot_" and g_currentMission.inGameMenu.ingameMenuTSStockCheck ~= nil then			
				moModule:showInGameMenuFrame("ingameMenuTSStockCheck", 0, true, false, 0);
			elseif app.name == "buyingSellingStationsSlot_" or app.name == "fillTypeAmountPriceSlot_" then
				moModule:showInGameMenuFrame("pagePrices", 0, true, false, 0);
			elseif app.name == "productionInfoSlot_" and g_currentMission.inGameMenu.InGameMenuProductionInfo ~= nil then
				moModule:showInGameMenuFrame("InGameMenuProductionInfo", 0, true, false, 0);
			elseif app.name == "productionInfoSlot_" or app.name == "factorys1Slot_" or app.name == "factorys2Slot_" or app.name == "factorys3Slot_" or app.name == "greenhouse1Slot_" or app.name == "greenhouse2Slot_" or app.name == "greenhouse3Slot_" then
				moModule:showInGameMenuFrame("pageProduction", 0, true, false, 0);			
			end;			
		end;
	end;
end;

function moSetGetLight.onDrawColorStateSlotPda(args)
	if args == nil or args.app == nil then return nil;end;
	if moSetGetOverlays[args.app.typ] ~= nil and moSetGetOverlays[args.app.typ][args.app.name] ~= nil then
		return moSetGetOverlays[args.app.typ][args.app.name].isOpen;
	end;
	return nil;
end;

function moSetGetLight.onActionPda(args) --Pda App Icons Callback
	if args == nil or args.pdaTable == nil or args.app == nil or args.mouseClick == nil or args.pda == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" then 
		local app = args.pdaTable.app[args.app];
		if app.typ == "pda" then
			local foundSlotPda = moSetGetLight:setPdaOpenCloseApp(args.pdaTable, args.app);
			if not foundSlotPda then
				guiDialog:autoGenerateSlotPda(args.pda, args.app);
			end;
		end;		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then
		local app = args.pdaTable.app[args.app];
		if app.typ == "pda" then
			if app.name == "animalsPda_" then
				moModule:showInGameMenuFrame("pageAnimals", 0, true, false, 0);	
			elseif app.name == "productionsPda_" then
				moModule:showInGameMenuFrame("pageProduction", 0, true, false, 0);
			end;
		end;
	end;
end;

function moSetGetLight.onActionCmd(args) --Cmd App Icons Callback
	if args == nil or args.pdaTable == nil or args.app == nil or args.mouseClick == nil or args.pda == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" then 
		local app = args.pdaTable.app[args.app];
		if app.typ == "cmd" then
			local foundCmd = moSetGetLight:setPdaCmdApp(app, "MOUSE_BUTTON_LEFT");
			if foundCmd ~= nil then
				if not foundCmd then
					g_currentMission.hl.addTextDisplay( {txt="CMD: ".. tostring(app.name.. " not found ! (Left Click)"), txtBold=true, duration=3} );
				end;
			end;
		end;		
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" then
		local app = args.pdaTable.app[args.app];
		if app.typ == "cmd" then
			local foundCmd = moSetGetLight:setPdaCmdApp(app, "MOUSE_BUTTON_RIGHT");
			if foundCmd ~= nil then
				if not foundCmd then
					g_currentMission.hl.addTextDisplay( {txt="CMD: ".. tostring(app.name.. " not found ! (Right Click)"), txtBold=true, duration=3} );
				end;
			end;
		end;
	end;
end;